<template>
  <div class="container" v-if="users.length > 0">
    <table class="table table-striped">
      <thead>
        <tr>
          <th scope="col">#</th>
          <th scope="col">Name</th>
          <th scope="col">Email</th>
          <th scope="col">DOB</th>
          <th scope="col">Phone</th>
          <th scope="col">Address</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(user, index) in users">
          <th scope="row">{{ index }}</th>
          <td>{{ user.username }}</td>
          <td>{{ user.email }}</td>
          <td>{{ user.dob }}</td>
          <td>{{ user.phone }}</td>
          <td>{{ user.address }}</td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import { ref, onBeforeMount } from "vue";
import { useRouter } from "vue-router";

export default {
  name: "Users",
  setup() {
    const router = useRouter();

    let users = ref([]);

    onBeforeMount(async () => {
      const response = await fetch("api/users", {
        headers: { "Content-Type": "application/json" },
        credentials: "include",
      });

      if (response.status == 401) {
        await router.push("/");
      }

      users.value = await response.json();
    });

    return {
      users,
    };
  },
};
</script>
